"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Addon = void 0;

var _components = require("@storybook/components");

var _react = _interopRequireWildcard(require("react"));

var _Panel = require("./Panel");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Addon = _ref => {
  let {
    active,
    browser,
    manager
  } = _ref;
  const [tests, setTests] = (0, _react.useState)([]);
  const [selectedTestId, setSelectedTestId] = (0, _react.useState)(manager.selectedTestId);
  (0, _react.useEffect)(() => {
    if (active) {
      manager.setActiveBrowser(browser);
      const browserTests = manager.getTestsByStoryIdAndBrowser(manager.activeBrowser);
      setTests(browserTests);
    }
  }, [active, browser, manager]);
  (0, _react.useEffect)(() => {
    const unsubscribe = manager.onChangeTest(testId => {
      setSelectedTestId(testId);
      const status = manager.getTestsByStoryIdAndBrowser(manager.activeBrowser);
      setTests(status);
    });
    return unsubscribe;
  }, [manager]);
  (0, _react.useEffect)(() => {
    const unsubscribe = manager.onUpdateStatus(() => {
      setTests(manager.getTestsByStoryIdAndBrowser(manager.activeBrowser));
    });
    return unsubscribe;
  }, [manager, browser]);
  return active ? tests.length ? /*#__PURE__*/_react.default.createElement(_Panel.Panel, {
    tests: tests,
    selectedTestId: selectedTestId,
    onChangeTest: manager.setSelectedTestId,
    onImageApprove: manager.onImageApprove
  }) : /*#__PURE__*/_react.default.createElement(_components.Placeholder, null, "No test results") : null;
};

exports.Addon = Addon;