"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tools = void 0;

var _react = _interopRequireWildcard(require("react"));

var _components = require("@storybook/components");

var _Icons = require("./Icons");

var _qs = require("qs");

var _theming = require("@storybook/theming");

var _types = require("../../../types");

var _helpers = require("../../shared/helpers");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Button = (0, _theming.styled)(_components.IconButton)({
  '&:disabled': {
    opacity: 0.5,
    cursor: 'default'
  },
  '&:disabled:hover': {
    color: 'inherit'
  }
});

const Tools = _ref => {
  let {
    manager
  } = _ref;
  const [buttonClicked, setButtonClicked] = (0, _react.useState)();
  const [isRunning, setRunning] = (0, _react.useState)(manager.status.isRunning);
  const forceUpdate = (0, _helpers.useForceUpdate)();
  const test = manager.getCurrentTest();
  (0, _react.useEffect)(() => {
    const unsubscribe = manager.onChangeTest(() => {
      forceUpdate();
    });
    return unsubscribe;
  }, [manager, forceUpdate]);
  (0, _react.useEffect)(() => {
    const unsubscribe = manager.onUpdateStatus(_ref2 => {
      let {
        isRunning
      } = _ref2;
      if ((0, _types.isDefined)(isRunning)) setRunning(isRunning);
    });
    return unsubscribe;
  }, [manager]);
  if (!test) return null;

  function renderButton(type, title, onClick, icon) {
    const handleClick = () => {
      setButtonClicked(type);
      onClick();
    };

    const disabled = isRunning && buttonClicked != null && buttonClicked !== type;
    return /*#__PURE__*/_react.default.createElement(Button, {
      onClick: () => {
        isRunning ? manager.onStop() : handleClick();
      },
      title: disabled ? '' : title,
      disabled: disabled
    }, buttonClicked === type && isRunning ? /*#__PURE__*/_react.default.createElement(_components.Icons, {
      icon: 'stop'
    }) : icon);
  }

  return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_components.IconButton, {
    href: "http://localhost:".concat(__CREEVEY_CLIENT_PORT__ || __CREEVEY_SERVER_PORT__, "/?").concat((0, _qs.stringify)({
      testPath: (0, _helpers.getTestPath)(test)
    })),
    target: "_blank",
    title: "Show in Creevey UI"
  }, /*#__PURE__*/_react.default.createElement(_components.Icons, {
    icon: "sharealt"
  })), /*#__PURE__*/_react.default.createElement(_components.Separator, null), renderButton('RunAll', 'Run all', manager.onStartAllTests, /*#__PURE__*/_react.default.createElement(_Icons.ForwardIcon, null)), renderButton('RunStoryTests', 'Run all story tests', manager.onStartAllStoryTests, /*#__PURE__*/_react.default.createElement(_Icons.NextIcon, {
    width: 15,
    height: 11
  })), renderButton('RunTest', 'Run', manager.onStart, /*#__PURE__*/_react.default.createElement(_components.Icons, {
    icon: "play"
  })));
};

exports.Tools = Tools;