"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.config = config;
exports.managerEntries = managerEntries;
exports.managerWebpack = managerWebpack;

var _path = _interopRequireDefault(require("path"));

var _shelljs = require("shelljs");

var _webpack = require("webpack");

var _helpers = require("../../server/storybook/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function config() {
  let entry = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return [...entry, require.resolve('./decorator')];
}

function managerEntries() {
  let entry = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return [...entry, require.resolve('./register')];
}

function managerWebpack(config, options) {
  var _options$presets$appl, _options$presets;

  // TODO How to execute with non-webpack bundlers
  if (options.configType == 'PRODUCTION' && options.skipExtract != true) {
    const args = [];
    if (options.creeveyPreExtract) args.push("--require \"".concat(options.creeveyPreExtract, "\""));
    args.push(_path.default.join(__dirname, '../../cli'));
    args.push("--extract \"".concat(options.outputDir, "\""));
    if (options.creeveyConfigPath) args.push("--config \"".concat(options.creeveyConfigPath, "\""));
    (0, _shelljs.exec)("node ".concat(args.join(' ')), {
      async: true
    });
  }

  return ((_options$presets$appl = (_options$presets = options.presets) === null || _options$presets === void 0 ? void 0 : _options$presets.apply('webpackInstance')) !== null && _options$presets$appl !== void 0 ? _options$presets$appl : Promise.resolve(undefined)).then(webpack => webpack !== null && webpack !== void 0 ? webpack : Promise.resolve("".concat((0, _helpers.resolveFromStorybookCoreServer)('webpack'))).then(s => _interopRequireWildcard(require(s)))).then(webpack => {
    var _config$plugins, _options$creeveyPort;

    const {
      DefinePlugin = _webpack.DefinePlugin
    } = webpack !== null && webpack !== void 0 ? webpack : {};
    (_config$plugins = config.plugins) === null || _config$plugins === void 0 ? void 0 : _config$plugins.push(new DefinePlugin({
      __CREEVEY_SERVER_HOST__: options.creeveyHost,
      __CREEVEY_SERVER_PORT__: (_options$creeveyPort = options.creeveyPort) !== null && _options$creeveyPort !== void 0 ? _options$creeveyPort : 3000,
      __CREEVEY_CLIENT_PORT__: options.clientPort
    }));
    return config;
  });
}