"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ADDON_ID = void 0;
exports.registerCreeveyPanels = registerCreeveyPanels;

var _addons = require("@storybook/addons");

var _react = _interopRequireDefault(require("react"));

var _Addon = require("./components/Addon");

var _Tools = require("./components/Tools");

var _Manager = require("./Manager");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const ADDON_ID = 'creevey';
exports.ADDON_ID = ADDON_ID;

_addons.addons.register(ADDON_ID, api => {
  void registerCreeveyPanels(api);
});

async function registerCreeveyPanels(storybookApi) {
  const manager = new _Manager.CreeveyManager(storybookApi);

  _addons.addons.addPanel("".concat(ADDON_ID, "/panel/run"), {
    title: "Creevey/Run",
    match: _ref => {
      let {
        viewMode
      } = _ref;
      return !!(viewMode && /^story$/.exec(viewMode));
    },
    type: _addons.types.TOOL,
    // eslint-disable-next-line react/display-name
    render: () => /*#__PURE__*/_react.default.createElement(_Tools.Tools, {
      manager
    })
  });

  await manager.initAll();
  const browsers = manager.getBrowsers();
  browsers.forEach(browser => {
    const panelId = "".concat(ADDON_ID, "/panel/").concat(browser);
    const title = manager.getTabTitle(browser);

    _addons.addons.addPanel(panelId, {
      title,
      type: _addons.types.PANEL,
      paramKey: browser,
      // NOTE key = PANEL_ID needs to correct render button in addons panel
      // eslint-disable-next-line react/display-name
      render: _ref2 => {
        let {
          active,
          key
        } = _ref2;
        return /*#__PURE__*/_react.default.createElement(_Addon.Addon, {
          active,
          key,
          manager,
          browser
        });
      }
    });
  });
}