"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getEmojiByTestStatus = getEmojiByTestStatus;
exports.isInternetExplorer = void 0;

function getEmojiByTestStatus(status) {
  let skip = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  switch (status) {
    case 'failed':
      {
        return '❌';
      }

    case 'success':
      {
        return '✔';
      }

    case 'running':
      {
        return '🟡';
      }

    case 'pending':
      {
        return '🕗';
      }

    default:
      {
        if (skip) return '⏸';
        return '';
      }
  }
}

const isInternetExplorer = navigator.userAgent.includes('Trident/');
exports.isInternetExplorer = isInternetExplorer;