"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BlendView = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ImagesView = require("./ImagesView");

var _theming = require("@storybook/theming");

var _helpers = require("../../helpers");

var _readyForCapture = require("../../../addon/readyForCapture");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Container = _theming.styled.div({
  position: 'relative',
  display: 'flex',
  filter: 'invert(100%)'
});

const ImageContainer = _theming.styled.div({
  position: 'absolute',
  width: '100%',
  height: '100%',
  display: 'flex'
});

const Image = _theming.styled.img(_ref => {
  let {
    borderColor
  } = _ref;
  return {
    boxSizing: 'border-box',
    border: "1px solid ".concat(borderColor),
    maxWidth: '100%',
    filter: 'invert(100%)'
  };
});

const ActualImage = (0, _theming.styled)(Image)({
  mixBlendMode: 'difference'
});
const DiffImage = (0, _theming.styled)(Image)({
  opacity: '0'
});
const BlendView = (0, _theming.withTheme)(_ref2 => {
  let {
    actual,
    diff,
    expect,
    theme
  } = _ref2;
  const expectImageRef = (0, _react.useRef)(null);
  const diffImageRef = (0, _react.useRef)(null);
  const actualImageRef = (0, _react.useRef)(null);
  const loaded = (0, _helpers.useLoadImages)(expect, diff, actual);
  const scale = (0, _helpers.useCalcScale)(diffImageRef, loaded);
  (0, _helpers.useApplyScale)(expectImageRef, scale, loaded);
  (0, _helpers.useApplyScale)(actualImageRef, scale, loaded);
  (0, _react.useEffect)(() => {
    if (loaded) (0, _readyForCapture.readyForCapture)();
  }, [loaded]);
  return /*#__PURE__*/_react.default.createElement(Container, null, /*#__PURE__*/_react.default.createElement(ImageContainer, null, /*#__PURE__*/_react.default.createElement(Image, {
    ref: expectImageRef,
    borderColor: (0, _ImagesView.getBorderColor)(theme, _ImagesView.themeBorderColors.expect),
    alt: "expect",
    src: expect
  })), /*#__PURE__*/_react.default.createElement(DiffImage, {
    ref: diffImageRef,
    borderColor: 'transparent',
    alt: "diff",
    src: diff
  }), /*#__PURE__*/_react.default.createElement(ImageContainer, null, /*#__PURE__*/_react.default.createElement(ActualImage, {
    ref: actualImageRef,
    borderColor: (0, _ImagesView.getBorderColor)(theme, _ImagesView.themeBorderColors.actual),
    alt: "actual",
    src: actual
  })));
});
exports.BlendView = BlendView;