"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SwapView = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ImagesView = require("./ImagesView");

var _theming = require("@storybook/theming");

var _helpers = require("../../helpers");

var _components = require("@storybook/components");

var _readyForCapture = require("../../../addon/readyForCapture");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Container = _theming.styled.div({
  position: 'relative',
  display: 'flex'
});

const BaseImage = _theming.styled.img(_ref => {
  let {
    borderColor
  } = _ref;
  return {
    boxSizing: 'border-box',
    border: "1px solid ".concat(borderColor),
    maxWidth: '100%'
  };
});

const Image = (0, _theming.styled)(BaseImage)({
  position: 'absolute'
});
const DiffImage = (0, _theming.styled)(BaseImage)({
  cursor: 'pointer',
  outline: 'none',
  opacity: 0,
  zIndex: 1
});
const SwapView = (0, _theming.withTheme)(_ref2 => {
  let {
    theme,
    expect,
    actual,
    diff
  } = _ref2;
  const [image, setImage] = (0, _react.useState)('actual');
  const expectImageRef = (0, _react.useRef)(null);
  const diffImageRef = (0, _react.useRef)(null);
  const actualImageRef = (0, _react.useRef)(null);
  const loaded = (0, _helpers.useLoadImages)(expect, diff, actual);
  const scale = (0, _helpers.useCalcScale)(diffImageRef, loaded);
  (0, _helpers.useApplyScale)(expectImageRef, scale, image);
  (0, _helpers.useApplyScale)(actualImageRef, scale, image);
  const handleChangeView = (0, _react.useCallback)(() => setImage(prevImage => prevImage == 'actual' ? 'expect' : 'actual'), []);
  (0, _react.useEffect)(() => {
    if (loaded) (0, _readyForCapture.readyForCapture)();
  }, [loaded]);
  return loaded ? /*#__PURE__*/_react.default.createElement(Container, null, /*#__PURE__*/_react.default.createElement(Image, {
    ref: expectImageRef,
    borderColor: (0, _ImagesView.getBorderColor)(theme, _ImagesView.themeBorderColors.expect),
    alt: 'expect',
    src: expect,
    hidden: image != 'expect'
  }), /*#__PURE__*/_react.default.createElement(DiffImage, {
    ref: diffImageRef,
    borderColor: 'transparent',
    tabIndex: 0,
    alt: "diff",
    src: diff,
    onClick: handleChangeView
  }), /*#__PURE__*/_react.default.createElement(Image, {
    ref: actualImageRef,
    borderColor: (0, _ImagesView.getBorderColor)(theme, _ImagesView.themeBorderColors.actual),
    alt: 'actual',
    src: actual,
    hidden: image != 'actual'
  })) : /*#__PURE__*/_react.default.createElement(_components.Loader, {
    size: 64
  });
});
exports.SwapView = SwapView;