"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = extract;

var _messages = require("./messages");

var _stories = require("./stories");

var _nodejs = require("./storybook/providers/nodejs");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

async function extract(config, options) {
  if (config.useWebpackToExtractTests && process.env.__CREEVEY_ENV__ != 'test') {
    await new Promise((resolve, reject) => {
      (0, _messages.subscribeOn)('webpack', message => {
        switch (message.type) {
          case 'success':
            return resolve();

          case 'fail':
            return reject();
        }
      });
      void (async () => (await Promise.resolve().then(() => _interopRequireWildcard(require('./loaders/webpack/compile')))).default(config, options))();
    });
  }

  const tests = await (0, _stories.loadTestsFromStories)(Object.keys(config.browsers), async () => {
    const data = await (0, _nodejs.extractStoriesData)(config, {
      watch: false,
      debug: options.debug
    });
    const stories = data.stories;
    if (options.extract) (0, _stories.saveStoriesJson)(data, options.extract);
    return stories;
  });
  if (options.tests) (0, _stories.saveTestsJson)(tests); // eslint-disable-next-line no-process-exit

  process.exit(0);
}