"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addMDXHook = void 0;

var _pirates = require("pirates");

var _helpers = require("../../storybook/helpers");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const addMDXHook = async getStory => {
  const mdx = (await Promise.resolve(`${(0, _helpers.resolveFromStorybookAddonDocs)('@mdx-js/mdx')}`).then(s => _interopRequireWildcard(require(s)))).default;
  const {
    mdxOptions
  } = await Promise.resolve().then(() => _interopRequireWildcard(require('../webpack/mdx-loader')));
  (0, _pirates.addHook)((code, filename) => {
    const story = getStory();
    if (!story || !filename.startsWith(story)) return code;
    return mdx.sync(code, mdxOptions());
  }, {
    exts: ['.mdx']
  });
};

exports.addMDXHook = addMDXHook;