"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.colors = void 0;
Object.defineProperty(exports, "getLogger", {
  enumerable: true,
  get: function () {
    return _loglevel.getLogger;
  }
});
exports.logger = void 0;

var _chalk = _interopRequireDefault(require("chalk"));

var _loglevel = _interopRequireWildcard(require("loglevel"));

var _loglevelPluginPrefix = _interopRequireDefault(require("loglevel-plugin-prefix"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const colors = {
  TRACE: _chalk.default.magenta,
  DEBUG: _chalk.default.cyan,
  INFO: _chalk.default.blue,
  WARN: _chalk.default.yellow,
  ERROR: _chalk.default.red
};
exports.colors = colors;

_loglevelPluginPrefix.default.reg(_loglevel.default);

_loglevelPluginPrefix.default.apply(_loglevel.default, {
  format(level, name = 'Creevey') {
    const levelColor = colors[level.toUpperCase()];
    return `[${name}:${_chalk.default.gray(process.pid)}] ${levelColor(level)} =>`;
  }

});

const logger = _loglevel.default.getLogger('Creevey');

exports.logger = logger;