"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.storiesOf = exports.setAddon = exports.raw = exports.getStorybook = exports.forceReRender = exports.configure = exports.clientApi = exports.clearDecorators = exports.channel = exports.addParameters = exports.addDecorator = void 0;

var _addons = require("@storybook/addons");

var _helpers = require("./helpers");

const framework = (0, _helpers.getStorybookFramework)(); // eslint-disable-next-line @typescript-eslint/no-var-requires

const core = require((0, _helpers.resolveFromStorybook)('@storybook/core-client'));

const start = core.start;
const api = start(() => void 0);

const channel = _addons.addons.getChannel();

exports.channel = channel;
const clientApi = api.clientApi;
exports.clientApi = clientApi;
const forceReRender = api.forceReRender;
exports.forceReRender = forceReRender;

const storiesOf = (kind, m) => {
  return clientApi.storiesOf(kind, m).addParameters({
    framework
  });
};

exports.storiesOf = storiesOf;

const configure = (...args) => {
  //NOTE Storybook 6.x pass `framework` as first argument
  //@ts-expect-error: ignore it
  return api.configure(framework, ...args);
};

exports.configure = configure;
const addDecorator = clientApi.addDecorator;
exports.addDecorator = addDecorator;
const addParameters = clientApi.addParameters;
exports.addParameters = addParameters;
const clearDecorators = clientApi.clearDecorators;
exports.clearDecorators = clearDecorators;
const setAddon = clientApi.setAddon;
exports.setAddon = setAddon;
const getStorybook = clientApi.getStorybook;
exports.getStorybook = getStorybook;
const raw = clientApi.raw;
exports.raw = raw;