const ie11Preset = ['@babel/preset-env', {
  targets: {
    ie: '11'
  }
}];
export const babel = config => {
  const {
    presets = []
  } = config;
  return { ...config,
    presets: [...(presets || []), ie11Preset]
  };
};
const nodeModulesThatNeedToBeParsedBecauseTheyExposeES6 = ['creevey', '@testing-library'];
const include = new RegExp("[\\\\/](".concat(nodeModulesThatNeedToBeParsedBecauseTheyExposeES6.join('|'), ")"));
const es6Loader = {
  test: /\.js$/,
  use: [{
    loader: require.resolve('babel-loader'),
    options: {
      presets: [ie11Preset]
    }
  }],
  include
};
export const managerWebpack = function () {
  var _webpackConfig$module, _webpackConfig$module2;

  let webpackConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return { ...webpackConfig,
    module: { ...webpackConfig.module,
      rules: [...((_webpackConfig$module = (_webpackConfig$module2 = webpackConfig.module) === null || _webpackConfig$module2 === void 0 ? void 0 : _webpackConfig$module2.rules) !== null && _webpackConfig$module !== void 0 ? _webpackConfig$module : []), es6Loader]
    }
  };
};
export const webpack = function () {
  var _webpackConfig$module3, _webpackConfig$module4;

  let webpackConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  const {
    entry
  } = webpackConfig;
  const polyfills = [require.resolve('whatwg-fetch')];

  if (Array.isArray(entry)) {
    polyfills.forEach(polyfill => {
      if (!entry.includes(polyfill)) {
        entry.unshift(polyfill);
      }
    });
  }

  return { ...webpackConfig,
    entry,
    module: { ...webpackConfig.module,
      rules: [...((_webpackConfig$module3 = (_webpackConfig$module4 = webpackConfig.module) === null || _webpackConfig$module4 === void 0 ? void 0 : _webpackConfig$module4.rules) !== null && _webpackConfig$module3 !== void 0 ? _webpackConfig$module3 : []), es6Loader]
    }
  };
};