import path from 'path';
import { exec } from 'shelljs';
import { DefinePlugin as FallbackDefinePlugin } from 'webpack';
import { resolveFromStorybookCoreServer } from '../../server/storybook/helpers';
export function config() {
  let entry = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return [...entry, require.resolve('./decorator')];
}
export function managerEntries() {
  let entry = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return [...entry, require.resolve('./register')];
}
export function managerWebpack(config, options) {
  var _options$presets$appl, _options$presets;

  // TODO How to execute with non-webpack bundlers
  if (options.configType == 'PRODUCTION' && options.skipExtract != true) {
    const args = [];
    if (options.creeveyPreExtract) args.push("--require \"".concat(options.creeveyPreExtract, "\""));
    args.push(path.join(__dirname, '../../cli'));
    args.push("--extract \"".concat(options.outputDir, "\""));
    if (options.creeveyConfigPath) args.push("--config \"".concat(options.creeveyConfigPath, "\""));
    exec("node ".concat(args.join(' ')), {
      async: true
    });
  }

  return ((_options$presets$appl = (_options$presets = options.presets) === null || _options$presets === void 0 ? void 0 : _options$presets.apply('webpackInstance')) !== null && _options$presets$appl !== void 0 ? _options$presets$appl : Promise.resolve(undefined)).then(webpack => webpack !== null && webpack !== void 0 ? webpack : import(resolveFromStorybookCoreServer('webpack'))).then(webpack => {
    var _config$plugins, _options$creeveyPort;

    const {
      DefinePlugin = FallbackDefinePlugin
    } = webpack !== null && webpack !== void 0 ? webpack : {};
    (_config$plugins = config.plugins) === null || _config$plugins === void 0 ? void 0 : _config$plugins.push(new DefinePlugin({
      __CREEVEY_SERVER_HOST__: options.creeveyHost,
      __CREEVEY_SERVER_PORT__: (_options$creeveyPort = options.creeveyPort) !== null && _options$creeveyPort !== void 0 ? _options$creeveyPort : 3000,
      __CREEVEY_CLIENT_PORT__: options.clientPort
    }));
    return config;
  });
}