import { addons } from '@storybook/addons';
import { getStorybookFramework, resolveFromStorybook } from './helpers';
const framework = getStorybookFramework(); // eslint-disable-next-line @typescript-eslint/no-var-requires

const core = require(resolveFromStorybook('@storybook/core-client'));

const start = core.start;
const api = start(() => void 0);
export const channel = addons.getChannel();
export const clientApi = api.clientApi;
export const forceReRender = api.forceReRender;
export const storiesOf = (kind, m) => {
  return clientApi.storiesOf(kind, m).addParameters({
    framework
  });
};
export const configure = (...args) => {
  //NOTE Storybook 6.x pass `framework` as first argument
  //@ts-expect-error: ignore it
  return api.configure(framework, ...args);
};
export const addDecorator = clientApi.addDecorator;
export const addParameters = clientApi.addParameters;
export const clearDecorators = clientApi.clearDecorators;
export const setAddon = clientApi.setAddon;
export const getStorybook = clientApi.getStorybook;
export const raw = clientApi.raw;