import { Configuration } from 'webpack';
export declare function config(entry?: string[]): string[];
export declare function managerEntries(entry?: string[]): string[];
declare global {
    const __CREEVEY_SERVER_HOST__: string;
    const __CREEVEY_SERVER_PORT__: number;
    const __CREEVEY_CLIENT_PORT__: number | null;
}
export interface CreeveyAddonOptions {
    creeveyConfigPath?: string;
    creeveyPreExtract?: string;
    creeveyHost?: string;
    creeveyPort?: number;
    clientPort?: number;
    configType: string;
    configDir: string;
    outputDir: string;
    skipExtract?: boolean;
    presets?: {
        apply: <T>(preset: string) => Promise<T | undefined>;
    };
}
export declare function managerWebpack(config: Configuration, options: CreeveyAddonOptions): Promise<Configuration>;
