import { NodePath, Binding, TraverseOptions } from '@babel/traverse';
export declare enum FileType {
    Invalid = -1,
    Entry = 0,
    Preview = 1,
    Story = 2
}
export interface VisitorState {
    resourcePath: string;
    fileType: FileType;
    isMDX: boolean;
    visitedTopPaths: Set<NodePath<any>>;
    visitedBindings: Set<Binding>;
    reexportedStories: Map<string, Set<string>>;
}
export declare const commonVisitor: TraverseOptions<VisitorState>;
export declare const previewVisitor: TraverseOptions<VisitorState>;
export declare const mdxVisitor: TraverseOptions<VisitorState>;
export declare const storyVisitor: TraverseOptions<VisitorState>;
